/*
 * Copyright (C) Jan 2006 Mellanox Technologies Ltd. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *  ConfFile.h - Configuration-file parsing class
 *
 *  Version: $Id: ConfFile.h 2752 2006-01-19 14:40:17Z mst $
 *
 */

#ifndef CONFFILE_H
#define CONFFILE_H

#include <string>

#include "IniFile.h"

#define CONF_DATA_GROUP_NAME "CONF_FILE_INFO"

class ParamList;
class ConfFile : public IniFile
{
public:
    ConfFile();
    virtual ~ConfFile();

    bool read(const char *fname, ParamList *plist);

protected:
    virtual bool group_start(const char *name);
    virtual bool param_start(const char *name, const char *value);

private:
    std::string  _cur_group;
    u_int32_t    _cur_geo;
    ParamList    *_plist;
};

#endif
